/*
 * Erstellt: 07.02.2006
 * Gendert: $Date$
 * 
 * $Log$
 */
package ec3.client;

import ec3.shared.Properties;
import ec3.shared.Tools;

/**
 * Das UserDetails-Plugin fr EasyChat.
 * <br>
 * Derzeit ist nur das Empfangen von Daten mglich, kein Senden.
 * 
 * @author am
 * @version 0.6
 * @since 0.6
 */
public class UserDetails
implements ProtocolExtension {
	
	/**
	 * Die interne Identifikation des Plugins.
	 */
	private static final String PLUGIN_ID = "ECUD_1.0";
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#sockCommand(java.lang.String, java.lang.String, ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public boolean sockCommand(String command, String data, Properties properties,
		ImplCallBack callBack) {
		
		String[] dataSplit = Tools.split (data, Tools.CHR0);
		
		try {
			//Pluginbefehl von anderem Client erhalten
			if (command.equals ("clientPluginData")) {
				
				//dataSplit[1] -> Plugindaten
				String[] dataSplit2 = Tools.split(dataSplit[0], Tools.CRLF);
				//^ 0 -> Plugin-ID  1 -> Befehl   2 -> Absender
				
				if (dataSplit2[0].equals(PLUGIN_ID)) {
					if (dataSplit2[1].equals("GetDetails")) {
						//TODO besser antworten
						//Antwort: leere Details
						callBack.sockCommand (
							"clientPluginData",
							PLUGIN_ID
							 + Tools.CRLF
							 + "Details"
							 + Tools.CRLF
							 + dataSplit2[2]
							 + Tools.CHR0
							 + "" // Name
							 + Tools.CHR1
							 + "0" // Geschlecht (0 -> keines, 1 -> Mann, 2 -> Frau)
							 + Tools.CHR1
							 + "00" // Geburtstag
							 + "00" // Geburtsmonat
							 + "0000" // Geburtsjahr
							 + Tools.CHR1
							 + "" // Hobbies
							 + Tools.CHR1
							 + "" // ICQ
							 + Tools.CHR1
							 + "" // AIM
							 + Tools.CHR1
							 + "" // YIM
							 + Tools.CHR1
							 + "" // MSN
							 + Tools.CHR1
							 + "" // eMail
							 + Tools.CHR1
							 + "" // Homepage (ohne http://)
							 + Tools.CHR1
							 + "" // Sprachen
							 + Tools.CHR1
							 + "Funktion wird noch nicht untersttzt" // Misc (mit CRLF drin)
							 + Tools.CHR1
							 + "" // Job
							 + Tools.CHR1
							 + "" // Bildlink
							 + Tools.CHR2
							 + "" // Country_1
							 + Tools.CHR1
							 + "" // State_1
							 + Tools.CHR1
							 + "" // Street_1
							 + Tools.CHR1
							 + "" // Zip_1
							 + Tools.CHR1
							 + "" // Town_1
							 + Tools.CHR1
							 + "" // Country_2
							 + Tools.CHR1
							 + "" // State_2
							 + Tools.CHR1
							 + "" // Street_2
							 + Tools.CHR1
							 + "" // Zip_2
							 + Tools.CHR1
							 + "" // Town_2
							 + Tools.CHR2
							 + "" // CPU
							 + Tools.CHR1
							 + "" // RAM
							 + Tools.CHR1
							 + "" // Grafikkarte
							 + Tools.CHR1
							 + "" // Soundkarte
							 + Tools.CHR1
							 + "" // Festplatte
							 + Tools.CHR1
							 + "0" // Verbindung
/*
Select Case CLng(Val(data(5)))
    Case 1: txtConnection.Text = "14.4 kBit Modem"
    Case 2: txtConnection.Text = "28.8 kBit Modem"
    Case 3: txtConnection.Text = "33.6 kBit Modem"
    Case 4: txtConnection.Text = "56 kBit Modem"
    Case 5: txtConnection.Text = "64 kBit ISDN"
    Case 6: txtConnection.Text = "128 kBit ISDN"
    Case 7: txtConnection.Text = "768 kBit DSL"
    '                            "1000 kBit DSL"
    Case 8: txtConnection.Text = "1500 kBit DSL"
    '                            "2000 kBit DSL"
    '                            "3000 kBit DSL"
    Case 9: txtConnection.Text = "10 MBit LAN"
    Case 10: txtConnection.Text = "11 MBit WLAN"
    Case 11: txtConnection.Text = "22 MBit WLAN"
    Case 12: txtConnection.Text = "44 MBit WLAN"
    Case 13: txtConnection.Text = "100 MBit LAN"
    Case 14: txtConnection.Text = "> 100 MBit LAN"
    Case Else
        pos = InStr(1, data(5), "/") ' 0/gaaaanz schnelle Verbindung
        If pos = 0 Then
            txtConnection.Text = language.data("unknown")
         Else
            txtConnection.Text = Right$(data(5), Len(data(5)) - pos)
        End If
End Select
*/
							 + Tools.CHR1
							 + "" // OS
							 + Tools.CHR1
							 + "" // Misc (mit CRLF drin)
						);
					} else if (dataSplit2[1].equals("Details")) {
						String[] details = new String[33];
						details[0] = dataSplit2[2];
						dataSplit = Tools.split(dataSplit[1], Tools.CHR2);
						dataSplit2 = Tools.split(dataSplit[0], Tools.CHR1);
						if (dataSplit2.length > 13) // neue Userdetails haben noch ein Feld mehr
							System.arraycopy(dataSplit2, 0, details, 1, 14);
						else {
							System.arraycopy(dataSplit2, 0, details, 1, 13);
							details[14] = "";
						}
						dataSplit2 = Tools.split(dataSplit[1], Tools.CHR1);
						System.arraycopy(dataSplit2, 0, details, 15, 10);
						dataSplit2 = Tools.split(dataSplit[2], Tools.CHR1);
						System.arraycopy(dataSplit2, 0, details, 25, 8);
						callBack.frontEndCommand("userDetails", details);
						//System.out.println(B64Hex.encode(dataSplit[1].getBytes(), B64Hex.HEX));
					} else {
						//ignorieren
					}
					
					return true;
				}
			} else if (command.equals("clientPluginResponse")) {
				// dataSplit[0] -> Grund (pluginnotfound/usernotfound)
				// dataSplit[1] -> Plugin-ID
				// dataSplit[2] -> Absender
				
				if (dataSplit[1].equals(PLUGIN_ID)) {
					callBack.frontEndCommand("userDetailsError", new String[] {dataSplit[0], dataSplit[2]});
					return true;
				}
			}
		} catch (ArrayIndexOutOfBoundsException e) {
			e.printStackTrace();
			callBack.frontEndCommand (
				"error",
				new String[] {"UserDetails/" + command + "/ArrayOutOfBounds"}
			);
			return true;
			
		}
		
		return false;
	}
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#sockError(java.lang.String, ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public void sockError(String data, Properties properties, ImplCallBack callBack) {
		// leer
	}
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#frontEndCommand(java.lang.String, java.lang.String[], ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public boolean frontEndCommand(String command, String[] data, Properties properties,
		ImplCallBack callBack) {
		if (command.equals ("message")) {
			
			//Leerzeichen etc. entfernen
			String message = data[0].trim ();
			
			if (message.startsWith ("/")) {
				
				//splitten in Befehl und angehngte Daten
				String[] messageSplit = null;
				//Daten gefunden
				if (message.indexOf (" ") > -1) {
					
					messageSplit = new String[2];
					messageSplit[0] =
					 message.substring (0, message.indexOf (" ")).toLowerCase ();
					messageSplit[1] =
					 message.substring (message.indexOf (" ") + 1);
					
				//keine Daten gefunden
				} else {
					
					messageSplit = new String[2];
					messageSplit[0] = message;
					messageSplit[1] = "";
					
				}//if
				
				if (messageSplit[0].equals("/whois")) {
					callBack.sockCommand (
						"clientPluginData",
						PLUGIN_ID
						 + Tools.CRLF
						 + "GetDetails"
						 + Tools.CRLF
						 + messageSplit[1]
						 + Tools.CHR0
					);
					
					return true;
				}
				
			}
			
		}
		return false;
	}
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#pluginCommand(java.lang.String, java.lang.String[], ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public boolean pluginCommand (String command, String[] data, Properties properties, ImplCallBack callBack) {
		// leer
		return false;
	}
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#connect(ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public void connect(Properties properties, ImplCallBack callBack) {
		//leer
	}
	
	/* (non-Javadoc)
	 * @see ec3.client.ProtocolExtension#disconnect(ec3.shared.Properties, ec3.client.ImplCallBack)
	 */
	public void disconnect(Properties properties, ImplCallBack callBack) {
		// leer
	}
}

