/*
 * Created on 28.06.2004
 */
package ec3.client.applet;

/**
 * ein Callback-Interface fr das Chatraumfenster
 * 
 * @author AM
 */
public interface ChatRoomListCallBack {
	
	/**
	 * Aktion: einen Chatraum betreten
	 */
	public static final int JOIN = 0;
	
	/**
	 * Aktion: einen Chatraum eratellen
	 */
	public static final int CREATE = 1;
	
	/**
	 * Aktion: einen Chatraum bearbeiten (geht nicht)
	 */
    public static final int EDIT = 2;
	
	/**
	 * die Methode wird aufgerufen, wenn im Chatraumfenster eine Aktion
	 * ausgefhrt wurde
	 * 
	 * @param room der betreffende Raum
	 * @param pwd das Passwort zum Raum
	 * @param desc die Beschreibung vom Raum
	 * @param action die Aktion (JOIN, CREATE, EDIT)
	 */
	public void chatRoomListCallBack (String room, String pwd, String desc,
	 int action);
	
}
