/*
 * Created on 10.07.2004
 */
package ec3.client.applet.launcher;

import java.util.Enumeration;
import java.util.Iterator;


/**
 * Adapterklasse von Enumeration auf Iterator
 * 
 * @author AM
 */
public class EnumerationIterator implements Iterator {
	
	/**
	 * die Enumeration
	 */
	private Enumeration e;
	
	/**
	 * erstellt einen neuen EnumerationIterator
	 * 
	 * @param e die Enumeration, ber die iteriert werden soll
	 */
	public EnumerationIterator (Enumeration e) {
		this.e = e;
	}
	/* 
	 * (non-Javadoc)
	 * @see java.util.Iterator#remove()
	 */
	public void remove() {
		throw new UnsupportedOperationException();
	}

	/* 
	 * (non-Javadoc)
	 * @see java.util.Iterator#hasNext()
	 */
	public boolean hasNext() {
		return e.hasMoreElements();
	}

	/* 
	 * (non-Javadoc)
	 * @see java.util.Iterator#next()
	 */
	public Object next() {
		return e.nextElement();
	}

}
