/*
 * Created on 13.07.2004
 */
package ec4.tools.version;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.event.MouseWheelEvent;
import java.util.Hashtable;

/**
 * Implementation von VersionController fr 1.1
 * 
 * @author AM
 */
class VersionControllerKaffe extends VersionController implements java.awt.event.MouseWheelListener {
	
	/**
	 * eine Liste aller zu forwardenden MouseWheelListener
	 */
	private Hashtable mwListeners;
	
	/**
	 * Konstruktor
	 */
	VersionControllerKaffe() {
		super();
		this.mwListeners = new Hashtable();
	}
	
	/* 
	 * (non-Javadoc)
	 * @see ec4.tools.ui.version.VersionController#setAntialiasing(java.awt.Graphics, boolean)
	 */
	public void setAntialiasing(Graphics g, boolean value) {
		// nix
	}
	
	/* 
	 * (non-Javadoc)
	 * @see ec4.tools.ui.version.VersionController#buildMouseWheelListener(java.awt.Component, ec4.tools.ui.version.MouseWheelListener)
	 */
	public void buildMouseWheelListener(Component c, MouseWheelListener l) {
		this.mwListeners.put(c, l);
		c.addMouseWheelListener(this);
	}
	
	/* 
	 * (non-Javadoc)
	 * @see ec4.tools.ui.version.VersionController#assertNetworkPerm()
	 */
	public void assertNetworkPerm() {
		// nix
	}
	
	/* 
	 * (non-Javadoc)
	 * @see java.awt.event.MouseWheelListener#mouseWheelMoved(java.awt.event.MouseWheelEvent)
	 */
	public void mouseWheelMoved(MouseWheelEvent e) {
		((MouseWheelListener)this.mwListeners.get(e.getSource())).mouseWheelMoved(e.getWheelRotation());
	}
}
