/*
 * Erstellt: 21.08.2006
 * Gendert: $Date$
 * 
 * $Log$
 */
package ec3.shared;


/**
 * Diese Klasse ermglicht die transparente Ver- und Entschlsselung von Daten.
 * 
 * @author am
 * @version $Id$
 */
public interface CryptoHook {
	
	/**
	 * Verschlsselt die gegebenen Daten.
	 * 
	 * @param data due zu verschlsselnden Daten.
	 * @return die verschlsselten Daten.
	 */
	byte[] encrypt(byte[] data);
	
	/**
	 * Entschlsselt die gegebenen Daten.
	 * 
	 * @param data due zu entschlsselnden Daten.
	 * @return die entschlsselten Daten.
	 */
	byte[] decrypt(byte[] data);
}

