/*
 * Created on 14.06.2004
 */
package ec4.tools.ui;

import java.util.EventObject;

/**
 * Ereignis zum Abfangen geklickter URLs
 * 
 * @author AM
 */
public class URLEvent extends EventObject {
	
	/**
	 * die URL, auf die geklickt wurde
	 */
	private String url;
	
	/**
	 * @param source die Quelle des Ereignisses
	 * @param url die geklickte URL
	 */
	public URLEvent(Object source, String url) {
		super(source);
		this.url = url;
	}
	
	/**
	 * fragt die geklickte URL ab
	 * 
	 * @return die geklickte URL
	 */
	public String getURL() {
		return this.url;
	}
}
